/**
 * Generic timer functions
 */

#include "ts_timer.h"
#include "tstcomm.h"

/**
 *
 */
static int32 ts_time_value;
volatile static uint8 ts_timer_mode;

#ifndef TS_TRACE32
static uint8 ts_index;
#endif


/**
 * Timer Initialization
 */
void ts_init_timer(uint16 timer_prescale_factor, uint8 timer_mode)
{
#ifndef TS_TRACE32
	ts_index = 0;
#endif
	ts_timer_mode = timer_mode;
}

/**
 * Start the Timer
 */
void ts_start_timer(void)
{
   ts_time_value = -1;
}

/**
 * Stop the Timer
 */
void ts_stop_timer(void)
{
#ifndef TS_TRACE32
	ts_index++;
#endif
}

/**
 * Send Timer result to master
 */
void ts_send_timer_result(void)
{
	tstcomm_put_long(ts_time_value);
}



/**
 * Breakpoint for writing timer result to file
 */
void ts_write_timer_result(void)
{
#ifndef TS_TRACE32
	if (ts_index > 99) {
		ts_flush_timer_results();
	}
#endif
}


/**
 * Breakpoint for writing timer result to file
 */
void ts_flush_timer_results(void)
{
#ifndef TS_TRACE32
	ts_index = 0;
#endif
}
